//+------------------------------------------------------------------+
//|                                                   MA Chanels.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "njel"
#property link      "iamnotlinked"

#property indicator_chart_window

#property indicator_buffers 8

#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 PaleVioletRed
#property indicator_color7 DimGray
#property indicator_color8 DimGray

#property indicator_style1 STYLE_DASHDOTDOT
#property indicator_style2 STYLE_DASHDOTDOT
#property indicator_style3 STYLE_DASH
#property indicator_width4 2
#property indicator_width5 2
#property indicator_style6 STYLE_DASH
#property indicator_style7 STYLE_DASHDOTDOT
#property indicator_style8 STYLE_DASHDOTDOT

extern int BarsCount = 0;
extern int MAPeriod  = 89;

double  max =0;
double  min =0;

double    Inc0 = 0.0000;
double    Inc1 = 0.0000;
double    Inc2 = 0.0000;
double    Inc3 = 0.0000;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

int init()
  {

   SetIndexStyle(0,DRAW_LINE);   SetIndexBuffer(0,ExtMapBuffer1);    SetIndexLabel(0,"50.0%");
   SetIndexStyle(1,DRAW_LINE);   SetIndexBuffer(1,ExtMapBuffer2);    SetIndexLabel(1,"38.2%");   
   SetIndexStyle(2,DRAW_LINE);   SetIndexBuffer(2,ExtMapBuffer3);    SetIndexLabel(2,"23.6%");   
   SetIndexStyle(3,DRAW_LINE);   SetIndexBuffer(3,ExtMapBuffer4);    SetIndexLabel(3,"0.0%");   

   SetIndexStyle(4,DRAW_LINE);   SetIndexBuffer(4,ExtMapBuffer5);    SetIndexLabel(4,"0.0%");      
   SetIndexStyle(5,DRAW_LINE);   SetIndexBuffer(5,ExtMapBuffer6);    SetIndexLabel(5,"23.6%");      
   SetIndexStyle(6,DRAW_LINE);   SetIndexBuffer(6,ExtMapBuffer7);    SetIndexLabel(6,"38.2%");   
   SetIndexStyle(7,DRAW_LINE);   SetIndexBuffer(7,ExtMapBuffer8);    SetIndexLabel(7,"50.0%");   

   return(0);
  }

int deinit()
  {
   max =0;
   min =0;
   return(0);
  }

int start()
  {

   max =0;
   min =0;

   if (iBars(NULL,0) < BarsCount)
      BarsCount = iBars(NULL,0) -MAPeriod-1 ;
      
   for (int i =BarsCount; i>=0; i--)
   {
      double m = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
      double top = High[i] - m;      
      if (top > max)
         max = top;
      
      double bottom = Low[i] - m;      
      if (bottom < min)
         min = bottom;
   }
   
   if (MathAbs(max) >  MathAbs(min))
      Inc0 = max;
   else
      Inc0 = min;

      Inc3 = Inc0*0.500;
      Inc2 = Inc0*0.382;
      Inc1 = Inc0*0.236;
      Inc0 = Inc0*0.0;

   for (i =BarsCount; i>=0; i--)
   {
      ExtMapBuffer1[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) + Inc3; 
      ExtMapBuffer2[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) + Inc2; 
      ExtMapBuffer3[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) + Inc1; 
      ExtMapBuffer4[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) + Inc0; 

      ExtMapBuffer5[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - Inc0;
      ExtMapBuffer6[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - Inc1;
      ExtMapBuffer7[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - Inc2;
      ExtMapBuffer8[i] = iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i) - Inc3;
   }

   return(0);
  }